"use strict";
// Globale variabler
var	amount = {},
	// Afgør hvornår spil er slut
	// X og Y-værdi i aktuelle regnestykke
	a, 				
	b,
	$timesTable = $("#table",$pageGame),			
	// Variabler relateret til input
	input=[], 			// Brugerens input som array af tal	
	// Ørige
	activeCell, 		// Id på activee cell
	intervalHandle,		// Stoppe/starte tidstagning 
	complementary = true, // Styrer om complementary equations vises
	equations=[],	// Array med alle equations
	vibrationAvailable = "vibrate" in navigator;

function responsive() {
if (gameIsActive) {
	var targetTable = $timesTable;
} else {
	var targetTable = $tableMake;
}
  // Størrelse på tekst og celle i udgangspunktet
  var cellSize = 60;
  var fontSize = "200%";
  // Variabler til beregning af tabelstørrelse
  var cellsX = x2-x1+2
  var cellsY = y2-y1+2
  var tablePadding = 5;
  if (gameIsActive) {
	var marginBottom = $("#keyboard-container").actual("height");
  } else {
	var marginBottom = $("#make-form-container").actual("height");
  }
  // Bestemmer tabellens bredde og højde
  var padding = 1;
  var borderSpacing = 1;
  // Tilpasser tabellens størrelse til skærmen, hvis tabellen er for stor. 
	  // maxTabelBredde regnes ud fra enten skærmens højde eller bredde, efter hvad der er mindst
	  var maxTableWidth = $(window).width()-(2*tablePadding);
	  var maxTableHeight = $(window).height()-marginTop-marginBottom-(2*tablePadding)-10;
	  var maxCellWidth = (maxTableWidth/cellsX) - (borderSpacing);
	  var maxCellHeight = (maxTableHeight/cellsY)- (borderSpacing);
	  var cellSize = Math.min(maxCellWidth,maxCellHeight,70);
	  amount.cellSize = cellSize;
  // Cellestørrelse hvis skærm er bred nok 
	  $("div.cell",targetTable).css({
	   		width : cellSize,
   	  		height : cellSize
	   });

	   // Calculates vertical align
	   var tableHeight = ((cellSize+2*padding+borderSpacing)*(cellsY));
	   var adjustTop = ($(window).height()-marginTop-marginBottom-tableHeight-10)/2;
	   if (adjustTop > 20) {
		   // Apply only if over 20px
		   $(targetTable).css({
			   "margin-top":adjustTop-10,
			   "margin-bottom":adjustTop-10
		   });
	   } else {
		// Remove evt. earlier added margin
			$(targetTable).css({
			   "margin-top":0
		   });
	   }
	  amount.scale = ((cellSize+3)<75) ? (75/(cellSize+3)) : null;
	  var fontsSize = cellSize;
	  var fontsSize = Math.max((cellSize*0.5),2);
	  $(targetTable).css("font-size",fontsSize);
	  var pxFontSize = $(targetTable).css('font-size');
	
}

function makeTable() {
	if (typeof amount.tableColor == "undefined") {
		amount.tableColor = "make-table";
	}
	var timesTable = document.createElement("div");
	$(timesTable).addClass("table");
	function cell(type,x,y) {
		var id="x"+x.toString()+"y"+y.toString();
		// Definer, tildel id og indsæt i dokument
		var td = document.createElement("div");
		$(td).attr("id",id);
		$(td).attr("class","cell");
		if (type == "th") {
				$(td).addClass("t-head");
			// Tekst ud for kolonner og rowr
				if (y==tableStartY) {
					$(td).text(x);
				} else {
					$(td).text(y);
					$(td).addClass("firstColumn");
				}
		}
		$(tr).append(td);
	}
// Lav rowr med cellr
	var tableStartX = x1-1;
	var tableStartY = y1-1;
	for (var y = tableStartY; y<=y2;y++) {
		var id="row"+y.toString() + "a";
		// Definer, tildel id og indsæt i dokument
		var tr = document.createElement("div");
		$(tr).addClass("row");
		$(tr).attr("id",id);
		for (var x = tableStartX;x<=x2;x++) {
			// Hvis row 1 eller kolonne 1
			if (y==tableStartY || x==tableStartX) {
				// Laver t-heads 
				new cell("th",x,y);
			} else {
			new cell("td",x,y);
			
			}
		}
	$(timesTable).append(tr); 
	}
	// Fjern værdien i cell (0,0)
	$("#x" + tableStartX.toString() + "y" + tableStartY.toString(),timesTable).text(""); 
	if (gameIsActive) {
		$(".cell",timesTable).addClass(amount.tableColor);
	}	
	if (gameIsActive) {
		var whereToPlace = $timesTable;
	} else {
		var whereToPlace = $tableMake;
	}
	$(whereToPlace).append(timesTable);
}

function shuffle(array) {
  var currentIndex = array.length
    , temporaryValue
    , randomIndex
    ;
  // While there remain elements to shuffle...
  while (0 !== currentIndex) {
    // Pick a remaining element...
    randomIndex = Math.floor(Math.random() * currentIndex);
    currentIndex -= 1;
    // And swap it with the current element.
    temporaryValue = array[currentIndex];
    array[currentIndex] = array[randomIndex];
    array[randomIndex] = temporaryValue;
  }
  return array;
}

function makeEquations(complementaryEquations) {
	// For hvert tal a
	for(var a=x1;a<=x2;a++) {
		// der skal ganges med hvert tal b
		for(var b=y1;b<=y2;b++) {	
		// If not on the no-fly complementary list
			if (typeof(complementaryEquations[a]) == "undefined" || typeof(complementaryEquations[a][b]) == "undefined") {
				equations.push([a, b]);
			}
		}
	}
	// Tæller antallet af equations
	amount.equations = Object.keys(equations).length;
}

function downlight() {
	// Farve row
	$("div", $timesTable).removeClass("highlight active");
	// Fjern active markering og erstat med udfyldt markering
	$(activeCell).addClass("udfyldt");
	// Fjern gul markering af tal
	$("div", $timesTable).removeClass("active-th");
	$(activeText).css({transform: "inherit"});
	$(activeText).css({"transform-origin": "inherit"});
}

function highlight() {
	// Farve row
	for (var x=x1;x<a;x++) {
		$("#x" + x + "y" + b, $timesTable).addClass("highlight");
	}
	// Farve kolonne
	for (var y=y1;y<b;y++) {
		$("#x" + a  + "y" + y, $timesTable).addClass("highlight");
	}
	$(activeCell).addClass("active");
	$("#x" + (x1-1)  + "y" + b,$timesTable).addClass("active-th");
	$("#x" + a + "y" + (y1-1),$timesTable).addClass("active-th");
	if (typeof amount.scale != 'undefined') {
		
		var digitsEquation = (a + "" + b).length;
		switch(digitsEquation) {
			case 4:
				var factor = 1.75;
				break;
			case 3:
				var factor = 1.40;
				break;
			default:
				var factor = 1;
		}
		var activeWidth = $(activeCell).width()*factor;
		var activeHeight= $(activeCell).height();
		// Get overflow left/right in px of scaled cell
		var overflowX = (activeWidth*amount.scale-activeWidth)/2;
		var overflowY = (activeHeight*amount.scale-activeHeight)/2;
		// Afstand fra nærmeste kant:
		var cellsLeft = (a-x1);
		var cellsRight = (x2-a);
		var cellsTop = (b-y1);
		var cellsBottom = (y2-b);
		var minDistanceX = Math.min(cellsLeft,cellsRight)*amount.cellSize;
		var minDistanceY = Math.min(cellsTop,cellsBottom)*amount.cellSize;
		var maxDistanceX = Math.max(cellsLeft,cellsRight)*amount.cellSize;
		var maxDistanceY = Math.max(cellsTop,cellsBottom)*amount.cellSize;
		// if (overflow>cellWidth) {CHECK for x1 or x2} else {
		var aTop = "inherit";
		var aRight = "inherit";
		var aBottom = "inherit";
		var aLeft = "inherit";
		if (overflowX>minDistanceX && overflowX<maxDistanceX) {
			if (cellsLeft<cellsRight) {
				var originX = "0%";
				aLeft = 0;
			} else {
				var originX = "100%";
				aRight = 0;
			}
		} else {
			var originX = "50%";
		}
		if (overflowY>minDistanceY && overflowY<maxDistanceY) {
			if (cellsTop<cellsBottom) {
				var originY = "0%";
			} else {
				var originY = "100%";
			}
		} else {
			var originY = "50%";
		}
		
		$(activeText).css({
				transform: "scale(" + amount.scale + ")",
				"transform-origin": originX + " " + originY,
				"left":aLeft,
				"right":aRight,
		});
	}
	
}



function textQuestion() {
	// Laver spørgsmål
	var question = a.toString() + "•" + b.toString();
	$(activeText).text(question);
}

var activeText;
function ask() {
	// Finder array med næste regnestykke
	a = equations[amount.calculated][0];
	b = equations[amount.calculated][1];
	// Sætter active cell
	activeCell = $("#x" + a + "y" + b,$timesTable);
	// Stiller spørgsmål
	activeText = document.createElement("div");
	$(activeText).css({
		"min-width":amount.cellSize,
		"min-height":amount.cellSize,
		"line-height":amount.cellSize + "px"
	});
	$(activeText).attr("id","active-text");
	textQuestion();
	$(activeCell).append(activeText);
	// highlighter inputfelt
	highlight();
}

/* *************************************************** */
/* ***************** FINISH_MESSAGE ****************** */
/* *************************************************** */


function message(text) {
	var container = $("#message-container",$finishedMessage);
	addTableColor($(container),amount.id)
	$("#message-text", $finishedMessage).text(text);
	function animateIn() {
		$("body").pagecontainer("change", $finishedMessage, {changeHash: false});	
		$(container).addClass("animated bounceInDown");
	}
	function animateOut() {
		$(container).removeClass("animated bounceInDown");
		$(container).addClass("animated bounceOutUp");
	}
	function over() {	
		$(container).removeClass("animated bounceOutUp");
	}
	
	animateIn()
	setTimeout(animateOut, 1100);
	setTimeout(over, 2500);
	// Time before next event (pagechange)
	return 2100;
}

function finished() {
	resetGame();
	clearInterval(intervalHandle);	
	var highscore = setScore(amount.id,amount.seconds,amount.errors.length);
	function showFinishedPage() {
		$("body").pagecontainer("change", $pageFinished, {});
	}
	// Table name upper right
	var tableName = nameTable(amount.id);
	$("#finished-table-name",$pageFinished).text(tableName);
	$("#page-title",$pageFinished).text(tableName);
	// Title
	if (highscore) {
		var text = "New highscore!";
	} else {
		var text = "Finished!";
	}
	// Time
		$("#finished-title", $pageFinished).text(timeShort(amount.seconds));
	// Errors
	$("#finished-errors", $pageFinished).text(amount.errors.length);
	var uniqueErrors = [];
	amount.errors.forEach(function(element,index) {	
		var minError = Math.min(element[0], element[1]);	
		var maxError = Math.max(element[0], element[1]);	
		var minMax = minError.toString() + maxError;
		if (typeof uniqueErrors[minMax]=='undefined') {
			uniqueErrors[minMax] = {"min": minError, "max": maxError, "times":1};
		} else {
			uniqueErrors[minMax].times++;			
		}
	});
	uniqueErrors.sort(function(a,b) {
    	return b.times - a.times;
	});
	$("#error-dom",$pageFinished).empty();
	var errorContainer = document.createElement("div");
	$(errorContainer).attr("id","error-list-container");
	uniqueErrors.forEach(function(element,index) {
		var errorItem = document.createElement("p");	
		var errorText = "<span class='equation-error'>" + element["min"] + "•" + element["max"] + "</span> (" + element["times"];
		errorText += (element["times"]>1) ? (" times)") : (" time)");
		$(errorItem).append(errorText);
		$(errorContainer).append(errorItem);
	});
	// Show errors if >0
	if (uniqueErrors.length==0) {
		//
		if (!$("#view-errors",$pageFinished).hasClass("hidden")) {
			$("#view-errors",$pageFinished).addClass("hidden");
		}
	} else {
		if ($("#view-errors",$pageFinished).hasClass("hidden")) {
			$("#view-errors",$pageFinished).removeClass("hidden");
		}
	}
	var finishButton = $(".finish-button",$pageFinished);
	addTableColor(finishButton,amount.id)
	$("#error-dom",$pageFinished).append(errorContainer);
	// Show/hide highscore medal
	var displayHighscore = highscore == true ? "inherit" : "none";
	$("#highscore-image",$pageFinished).css({
		"display": displayHighscore
	});
	// Control transistions
	var delay = message(text)
	setTimeout(showFinishedPage, delay);	

	var width = $(window).width();
	var height = $(window).height();
	var titleFontSize = 31.7+(width*0.2289);
	var margin = titleFontSize-60;
	var tableNameFontSize = (titleFontSize+100)/10; 
	$("#finished-title",$pageFinished).css({
		"font-size":titleFontSize,
		"margin-bottom":margin,
		"line-height": titleFontSize*0.75 + "px"
	});
	$("#finished-table-name",$pageFinished).css({
		"font-size":tableNameFontSize,
		"margin-top":margin,
		"line-height": tableNameFontSize*0.75 + "px"
	});
	var zoom = 1;
	if (width >= 320) {
		zoom = 1.1 + (0.001875*(width-320));
	}
	$("#finish-list",$pageFinished).css({
		"zoom":zoom
	});
	var higscoreHeight = 0.2*height;
	var heighscoreMargin = (-0.15)*height+60;
	$("#highscore-image",$pageFinished).css({
		"height": higscoreHeight,
		"background-size": higscoreHeight + "px " + higscoreHeight + "px",
		"margin-bottom": heighscoreMargin
	});
	if (is_ios){
		/* Fix for iOS zoom on which text */
		$("#view-errors",$pageFinished).css({
			"font-size":14*zoom + "px"
		});
		$("#statZoom",$pageFinished).css({
			"zoom":1,
			"transform": "scale(" + zoom + ")",
			"text-align": "right"
		});

	}

	
}

$("#stats",$pageFinished).click(function () {
	if(playedTables[amount.id].played<2) {
		$.mobile.changePage($statDialog, {role: "dialog", transition: 'pop'});
		playFirstMessage(amount.id);
		return;	
	}
	$("body").pagecontainer("change", $pageStats, {});
	makeChart(amount.id);	
})

function correct() {
	amount.calculated++;
	downlight();
	$(activeCell).empty();
	$(activeCell).text(a * b);
	if (amount.calculated==amount.equations) {
		finished();
	} else {
		ask();	
	}
}

function wrong() {
	amount.errors.push([a,b]);
	amount.errorDisplay.text(amount.errors.length);
	//navigator.notification.vibrate(100);
	if(vibrationAvailable) {
		navigator.vibrate(100);
	}
	//error_sound.play();
	lla.play( error_sound );
	$(activeText).addClass("wrong");
	function removeWrong() {
		$(activeText).removeClass("wrong");
	}
	setTimeout(removeWrong, 200)
	textQuestion();
	}

function tick() {
	// Seconds into mm:ss
	amount.seconds++;
	var min = Math.floor(amount.seconds/60);
	var sec = amount.seconds - (min*60);
	// leadning zero if seconds less than 10.
	if (sec<10) {
		sec = "0" + sec;
	}
	var message = min + ":" + sec;
	amount.timeDisplay.html(message);
}

function newGame(id) {
	if (gameIsActive) {
		// Sikrer, at der ikke er tilfælde hvor der startes to spil
		resetGame();
	}
	// Prevent screen sleep
	window.plugins.insomnia.keepAwake();
	// Sætter spil activet -> tasteturtryk aflæses mv.
	gameIsActive=true;
	var tableElement = playedTables[id];
	x1=tableElement.table[0];
	x2=tableElement.table[1];
	y1=tableElement.table[2];
	y2=tableElement.table[3];
	complementary=tableElement.table[4];
	// Bogførings-variable.
	window.amount.calculated = 0;
	window.amount.id = id;
	window.amount.seconds = -1;
	window.amount.errors = [];
	window.amount.tableColor=tableElement.color;
	// Save DOM elements for speed
	window.amount.gameInfo=$("#game-info",$pageGame);
	window.amount.timeDisplay=$("#time-display",amount.gameInfo);
	window.amount.errorDisplay=$("#error-display",amount.gameInfo);
	// lav tabel
	makeTable();
	// Fjern complementary 
	if (!complementary) {
		var complementaryEquations = removeComplementary();
	} else {
		var complementaryEquations = [];
	}
	// lav equations
	makeEquations(complementaryEquations);
	// Responsiveness
	responsiveKeyboard();
	responsive();
	// Ryster posen
	shuffle(equations);                             
	// Vis amount.errors
	amount.errorDisplay.text(amount.errors.length);
	addTableColor(amount.gameInfo,amount.id)
	// Bestem og vis det første regnestykke
	ask();
	// Start tidstagning
	tick(); // Vis "Antal sekunder:0:00)
	intervalHandle = setInterval(tick,1000);
}

function resetGame() {
	// Allow screen sleep again
	window.plugins.insomnia.allowSleepAgain()
	// Sletter gangetabel, equations og bogføring
	$timesTable.empty(); 	
	$("#keyboard-container",$pageGame).empty();
	equations=[];	
	input=[];
	clearInterval(intervalHandle);	
	gameIsActive=false;
}

function evaluateInput() {
	// Evaluer input hvis cifre i input er lig cifre i facit  
	  var answer = input.join("");
	  $(activeText).text(answer);
	  var facitLength = (a*b).toString().length;
	  var inputLength = input.length;
	  if (input.length == 0) {
		  textQuestion();
	  }
	  if (inputLength>=facitLength) {
		  // Brugerens svar som tal (array->tal)
		  var facit = a*b;
		  // nulstil inputfelt
		  input=[];
		  if (answer==facit) {

			correct();  
		  } else {
			  wrong();
		  }
		  
	  }
}
/******************************************/
/***************** KEYBOARD ***************/
/******************************************/
// Function create tastetur
function createKeyboard (keysPerRow, keyWidth) {
	var keyboard = document.createElement("div");
		
	function key(number) {
		var id="key" + number;
		// Definer, tildel id og indsæt i dokument
		var button = document.createElement("button");
		$(button).attr("id",id);
		$(button).attr("class","key ui-btn");
		$(button).attr("value",number);
		if (number == "bksp") {
			$(button).html('<i class="fa fa-long-arrow-left"></i>');
		} else {
			$(button).text(number);
		}
		$(keyboard).append(button);
	}
	function row() {
		var br = document.createElement("br");
		$(keyboard).append(br);
	}
	// Create keys 0-10
	for (var i=1; i<=10; i++) {
		if (i!=10) {
			new key(i);	
			if (i%keysPerRow==0) {
				new row();
			}
		} else {
			// Create number 0 last
			new key(0);
		}
	}
	new key("bksp");
	$(keyboard).attr("id","keyboard");	
	$("#keyboard-container",$pageGame).append(keyboard);
}

function keyPress() {
	
}

function responsiveKeyboard() {
	// Window height and width
	var screenWidth = $(window).width()-7;
	var screenHeight = $(window).height();
	// Calculate width of button
	var minWidth = 70;
	var paddingHorizontal = 7;
	// 0-9 = 10 buttons. Backspace = 2
	var buttons = 12;
	var rows = 4;
	/*if ((minWidth+paddingHorizontal)*buttons-paddingHorizontal <= screenWidth) {
		var rows = 1;
	} else {
		var rows = 4;
	}*/
	var keysPerRow = buttons/rows;
	var keyWidth = (screenWidth/keysPerRow)-paddingHorizontal;
	var keyWidth = Math.min(170,keyWidth);
	var keyHeight = 40;
	if (keyWidth > 100) {
		keyHeight = 40+0.214*(keyWidth-100);
	}
	createKeyboard (keysPerRow);
	$(".key",$pageGame).css({
		"width": keyWidth,
		"height": keyHeight
	});
	var touches=[];
	$(".key",$pageGame).on("touchstart", function(event) {
		event.preventDefault();
    	event.stopPropagation();
		keyPress();
//		navigator.notification.vibrate(20);
//		clank.play();
		if(vibrationAvailable) {
			navigator.vibrate(10);
		} 
			lla.play( click_sound );
		
		$(this).addClass('touchactive');
	}).on("touchend", function() {
		$(this).removeClass('touchactive');
		if(!gameIsActive) {
			// Tjek at key er hovered
			return;
		}
		if (isNaN($(this).val())) {
			input.pop();
			evaluateInput();
			return;
		}
		input.push(parseInt($(this).val()));
		evaluateInput();
	});
}

$(document).ready(function() {
  // Vis brugers input i celle
	// Ved tryk på tastetur A-Å
  $(document).keypress(function(e) {
	  // Hvis spil er startet
	  if (!gameIsActive) {
		  return;
	  }
	  // Fra charCode til bogstav
	  var key = String.fromCharCode(e.which);
	  // Godtag kun tal
	  if (isNaN(key)) {
		  return;
	  }
	  // Indsæt i array og nulstil inputfelt
	  input.push(key);
	  evaluateInput();
	 });

  // Sikrer at backspace ikke gør, at browseren går en side tilbage
  $(document).keydown(function(e) {
  var element = e.target.nodeName.toLowerCase();
  if (element != 'input' && element != 'textarea') {
	  if (e.keyCode === 8) {
		  return false;
	  }
  }
  });
  // Slette-funktion i celle
	// Ved tryk på tastetur
	$(document).keyup(function(e) {
		// Hvis spil er startet
		if (!gameIsActive) {
			return;
		}
		// Ved backspace
		if(e.keyCode == 8) {
			// Slet sidste element i array
			input.pop();
			evaluateInput();
		}
	});

/******************************************/
/**************** DOCUMENT LOAD ***********/
/******************************************/

	$( window ).resize(function() {
		if(gameIsActive) {
			$("#keyboard-container",$pageGame).empty();
			responsiveKeyboard();
			responsive();
		}
		responsiveFrontpage();
	});
	$("#play-again",$pageFinished).bind("vclick",function() {
		// Skift side
		$("body").pagecontainer("change", $pageGame, {});
		// Start forfra på spillet
		newGame(amount.id);
	});
	$("#reset-game",$pageGame).bind("vclick",function() {
		// Nulstiller variable
		resetGame();
		// Start forfra på spillet
		newGame(amount.id);
	});
});

