window.addEventListener('load', function() {
    FastClick.attach(document.body);
}, false);
// Bestemmer afstand fra toppen af skærmen
var marginTop = 44 // Nav bar + 5 padding

document.addEventListener('deviceready', function() {
  navigator.splashscreen.hide();
});

// Check browser
//var is_chrome = navigator.userAgent.toLowerCase().indexOf('chrome') > -1;
var is_ios = navigator.userAgent.match(/(iPad|iPhone|iPod)/g) ? true : false;
// If chrome || safari: fix problem with flickering/no rendering of active cell

if (is_ios){
// adapt to statusbar in iOs 7+
    //StatusBar.styleBlackTranslucent();
	function onDeviceReady() {
		StatusBar.overlaysWebView(true);
		StatusBar.styleLightContent();
	}
	document.addEventListener("deviceready", onDeviceReady, false);
	document.write('<link rel="stylesheet" href="css/ios-header.css" type="text/css" />');
	marginTop +=20;  
}



var click_sound = 'assets/clank.mp3';
//var error_sound = new Audio("assets/error.mp3");
var error_sound = 'assets/error.mp3';

var lla;
function loadAudio() {
	if( window.plugins && window.plugins.LowLatencyAudio ) {
		lla = window.plugins.LowLatencyAudio;
		if (is_ios) {
			lla.preloadAudio( click_sound, click_sound, 1, 1, function(msg){}, function(msg){ console.log( 'Error: ' + msg ); });
			lla.preloadAudio( error_sound, error_sound, 1, 1, function(msg){}, function(msg){ console.log( 'Error: ' + msg ); });
		} else {
			lla.preloadFX( click_sound, click_sound, function(msg){}, function(msg){ console.log( 'Error: ' + msg ); });
			lla.preloadFX( error_sound, error_sound, function(msg){}, function(msg){ console.log( 'Error: ' + msg ); });
		}
	}
}
document.addEventListener('deviceready', loadAudio, false);

// Forhindre copy/paste selection
document.documentElement.style.webkitTouchCallout = "none";
document.documentElement.style.webkitUserSelect = "none";
var playedTables={};
var storedTables,
	historyBackPage,
	tableColors,
	gameIsActive=false,
	x1,
	x2,
	y1,
	y2,
	statId,
	complementary,
	deleteID,
	newItemAdded = false,
	// Controls whether to reload tablelist
	tableDeleted = false,
	$pageGame = $("#page-game"),
	$pageStats = $("#page-stats"),
	$pageFinished = $("#page-finished"),
	$pageMake = ("#page-make"),
	$pageHome = $("#page-home"),
	$tableMake = $("#table-make",$pageMake),
	$finishedMessage = $("#page-finished-message"),
	$deleteDialog = $("#delete-dialog"),
	$statDialog = $("#stat-dialog");


/* *************************************************** */
/* *************** LOCAL STORAGE API ***************** */
/* *************************************************** */
/* TABLE */
function updateStoredTables() {
	var string = JSON.stringify(playedTables);
	window.localStorage.setItem("tableList",string);
}

function addTable(array,colorIndex,animate) {
	tableColors[colorIndex].used++;
	var string = JSON.stringify(tableColors);
	window.localStorage.setItem("colors",string);
	var tableItem = {table:array,highscore:null,played:0,color:tableColors[colorIndex].color,animate:animate};
	var id = "table" + array.join("-");
	playedTables[id] = tableItem;
	updateStoredTables();
}

function deleteTable(id) {
	tableDeleted = true;
	$deleteDialog.dialog("close");
	tableColors.forEach(function(element) {
		if (element.color==playedTables[id].color) {
			element.used--;
			var string = JSON.stringify(tableColors);
			window.localStorage.setItem("colors",string);
		}
	});
	playedTables[id].color;
	delete playedTables[id];
	updateStoredTables();
	window.localStorage.removeItem(id);
	$("#"+id).addClass("animated flipOutX");
	setTimeout(function (){
		$("#"+id).addClass("hidden");
	 }, 900); // how long do you want the delay to be? 	
	 // Set tableDeleted = true, to not reload the tableList
	 
}

function retrieveTableList() {
	storedTables = window.localStorage.getItem("tableList");
	if (storedTables == null) {
		// Hvis først gang / local Storage ikke defineret
		addTable([1,9,1,9,true],pickColor(),false);
	} else {
		// Parse array of object from JSON string
		playedTables = JSON.parse(storedTables);
	}
}

function retrieveTableData(id) {
	storedTableDate = window.localStorage.getItem(id);
	return JSON.parse(storedTableDate);
}

/* Colors */
function retrieveTableColors() {
	var storedColors = window.localStorage.getItem("colors");
	if (storedColors == null) {
		tableColors = [];
		array = ["green","blue","orange","purple","yellow","red"];
		array.forEach(function(color) {
			tableColors.push({color:color,used:0});
		});
	} else {
		tableColors = JSON.parse(storedColors);
	}
}

/* SCORE */
function setScore(playedID,score,errors) {
// Find table item 
	var tableElement = playedTables[playedID];
//Check if highscore and +1 played times
	if (tableElement["highscore"]==null || score<tableElement["highscore"]) {
		tableElement["highscore"]=score;
		var newHighScore  = true;
	}
	tableElement["played"]++;
	updateStoredTables()
// Add new tableScore
	storedTable = window.localStorage.getItem(playedID);
	// Get array
	if (storedTable == null) {
		// Hvis først gang / local Storage ikke defineret
		var tableScores = []
	} else {
		// Parse array of objects from JSON string
		var tableScores = JSON.parse(storedTable);
	}
	var today = new Date().getTime();
	tableScores.push([score,errors,today]);
	// Save to local storage
	var string = JSON.stringify(tableScores);
	window.localStorage.setItem(playedID,string);
// Return whether new highscore 
	if (newHighScore) {
		return true;
	} else {
		return false;
	}
}



/* *************************************************** */
/* ***************** THE ENGINE ********************** */
/* *************************************************** */
function time(seconds) {
	// Returns time in [min] min. [sec] sec
	var min = Math.floor(seconds/60);
	var sec = seconds - (min*60);
	return min>0 ? min + " min. " + sec + " sec." : sec + " sec.";
}

function timeShort(seconds) {
	// Returns time in min:sec
	var min = Math.floor(seconds/60);
	var sec = seconds - (min*60);
	// add leading 0 if neaded
	var sec = sec<10 ? "0"+sec : sec;
	return min + ":" + sec;
}

function nameTable(id) {
	var tableName;
	var comp = "";
	var tableElement = playedTables[id].table;
	x1 = tableElement[0];
	x2 = tableElement[1];
	y1 = tableElement[2];
	y2 = tableElement[3];
	complementary = tableElement[4];
	function isComplementary() {
		if (!complementary) {
			tableName += " (-comp)";
		}
	}
	function yTable () {
	// Eg. '9-table' or '12-table (from x to y)'
		if (x1==x2) {
		// If horisontal 
			var timeTable = x1;
			var timeStart = y1;
			var timeEnd = y2;
		} else {
		// if vertical
			var timeTable = y1;
			var timeStart = x1;
			var timeEnd = x2;
		}
		//Add to-from text if needed
		var paranthesis = "("+timeStart+"-"+timeEnd+")";
		tableName = timeTable + " Times Table " + paranthesis;
	}
	function xyTable () {
	// Eg. 9*9 or 2*3
	tableName = x2 + "•" + y2 + " Table";
	isComplementary();
	}
	function xxyyTable () {
	// Eg. 2*2-9*9
	tableName = x1 + "•" + y1 + "-" + x2 + "•" + y2 + " Table";
	isComplementary();
	}
	
	if (x1==x2 || y1==y2) {
	// y-table
		yTable();
	} else if (x1==1 && y1==1) {
	// x*y-table
		xyTable();
	} else {
	// Custom table
		xxyyTable();
	}
	
	return tableName;
}

function pickColor() {
	  // Check for unused colors
	  for (i=0;i<tableColors.length;i++) {
		  if (tableColors[i].used == 0) {
			  return i;
		  }
	  }
	  // No unused - pick random
	  return Math.floor(Math.random()*tableColors.length);	
}

function addTableColor(element,tableIdOrColorIndex) {
	var currentElementColor = element.attr("color");
	if (!isNaN(tableIdOrColorIndex)) {
		// Index to color
		var newElementColor = tableColors[tableIdOrColorIndex].color;
	} else {
		// TableID
		var newElementColor = playedTables[tableIdOrColorIndex].color;
	}
	if (currentElementColor != null) {
		element.removeClass(currentElementColor);
	}
	element.attr("color", newElementColor);
	element.addClass(newElementColor);	
}


function removeComplementary() {
	var complementaryEquations = [];
	var complementaryAmount=0;
	var upperMax = Math.max(x2,y2);
	var upperMin = Math.min(x2,y2);
	var lowerMax = Math.max(x1,y1);
	var lowerMin = Math.min(x1,y1);
	var overlap = (upperMin-lowerMax);
	for (var i=upperMin;i>(upperMin-overlap)-1;i--) {
		complementaryEquations[i]=[]
		for (var o=i+1;o<=upperMin;o++) {
			if (gameIsActive) {
				var target=$pageGame;
			} else {
				var target=$pageMake;
			}
			$("#x"+i+"y"+o,target).addClass("complementary");
			complementaryEquations[i][o]='1';
			complementaryAmount++;
		}
	}
	if (gameIsActive) {
		return complementaryEquations;
	} else {
		return complementaryAmount;
	}
}

/* *************************************************** */
/* ***************** statDialog ********************** */
/* *************************************************** */
var statID;
function playFirstMessage(id) {
	statID = id;
	var message = document.createElement("div");
	$(message).text("id");
	$(message).attr("id","canvas");
	$(statContainer).append(message);
	addTableColor($("#stat-play",$statDialog),id);
}

$("#stat-play",$statDialog).click( function() {
	$("body").pagecontainer("change", $pageGame, {transition: 'slide'});
	newGame(statID);
});

$(".back-stat-dialog",$statDialog).click( function() {
	$statDialog.dialog("close");
});

/* *************************************************** */
/* ****************** FRONTPAGE ********************** */
/* *************************************************** */

function responsiveFrontpage() {
	var width = $(window).width();

	// Responsive logo
	var factor = width/320;
	if (factor>1) {
		// Magic equation
		var scale = 1+((factor-1)/4);
		$("#logo",$pageHome).css({
			"zoom":scale,
		})
	}
// Bestem height of buttons
/*	if (height>600) {
		// Max height 1000
		height = Math.min(height,1000);
		var scalePixels = (height-600)*0.025;
		var buttonHeight = 44+scalePixels;
		console.log(buttonHeight);
		console.log($("div.cell .ui-btn"));
		$("div.cell .ui-btn").css({
			"height":buttonHeight,
			"padding":"0 inherit"
		});
	}*/
		
}

function viewTableList() {
		var $playedList = $("#played-list");
		var listColors = ["green","orange","blue"]
		var tablesLookup={};
		var listUl =$('<ul data-role="listview" data-split-theme="a" data-inset="true" class="ui-listview ui-listview-inset ui-corner-all ui-shadow">');
for (var key in playedTables) {
   		var tableElement = playedTables[key];
		var liColor = tableElement["color"];
		var id = "table" + tableElement["table"].join("-");
		var listLi = $('<li class="ui-li-has-alt ui-li-has-thumb listview-background-li ' + liColor + '">');
			listLi.attr("id",id);
			if (tableElement.animate==true) {
				playedTables[key].animate=false;
				updateStoredTables();
				listLi.addClass("hidden");	
			}
		var listIconRight = $('<div class="listview-icon-right"><i class="fa fa-chevron-right"></i></div>');
		var listContent = $('<a href="javascript: void(0)" class="ui-btn listview-background start-game">');
			$(listContent).attr("tableID", id);
			var listIconLeft = $('<div class="listview-icon-left"><i class="fa fa-play-circle"></i></div>');
			var listTitle = $(document.createElement('h2'));
			listTitle.text(nameTable(id));
			$(listTitle).addClass("list-title");
			$(listContent).append(listIconLeft);
			$(listContent).append(listTitle);
			if (tableElement["played"] == 0) {
				$(listTitle).addClass("oneline");
				var notPlayed =  $(document.createElement('p')).text("Not played yet");
				$(listContent).append(notPlayed);
			} else {
				var listRecord =  $(document.createElement('p'));
				var listPlayed =  $(document.createElement('p'));
				listRecord.text("Highscore: " + time(tableElement["highscore"]));
				var timeOrTimes = tableElement["played"]>1 ? "times" : "time";
				listPlayed.text("Played " + tableElement["played"] + " " + timeOrTimes);
				$(listContent).append(listRecord);
				$(listContent).append( listPlayed);
			}
			
		var listButtons = $('<div class="ui-put">');
			listTrash = $('<a href="#delete-dialog" aria-expanded="false" data-rel="dialog" data-transition="pop" class="btn-listview delete-game btn-listview-top fa fa-trash-o fa-fw"></a>');
				listTrash.attr("tableID",id);
			listStats = $('<a aria-expanded="false" class="btn-listview btn-listview-bottom stat-game fa fa-bar-chart-o fa-fw"></a>');
				listStats.attr("tableID",id);
			if (key != "table1-9-1-9-true") {
				$(listButtons).append(listTrash);
			} else {
				listStats.addClass("first");
			}
			$(listButtons).append(listStats);
		$(listLi).append(listIconRight);
		$(listLi).append(listContent);
		$(listLi).append(listButtons);
		$(listUl).append(listLi);
		tablesLookup[id] = tableElement["table"];
	};
	$(".start-game", listUl).click(function() {
		id = $(this).attr('tableID');
		newGame(id);
		$("body").pagecontainer("change", $pageGame, {transition: 'slide'});
	});
	$(".delete-game", listUl).click( function() {
		deleteID = $(this).attr('tableID');
		$("#deleteTableName",$deleteDialog).text(nameTable(deleteID));
		var deleteButton = $("#delete-table",$deleteDialog);
		addTableColor(deleteButton,deleteID);		
	});
	$(".stat-game", listUl).click( function() {
		statID = $(this).attr('tableID');
		if(playedTables[statID].played<2) {
			$.mobile.changePage($statDialog, {role: "dialog", transition: 'pop'});
			playFirstMessage(id);
			return;	
		}
		$("body").pagecontainer("change", $pageStats, {});
		makeChart(statID);
	});
	$("#listContainer").append(listUl);
		$($pageHome).on( "pageshow", function( event ) {
			if (newItemAdded == true) {
				newItemAdded = false;
				// Ensures new-table dosent animate
				var listContainer = $("#listContainer",$pageHome);
				var last_li = $("li:last-child",listContainer);
				var newTableLi = $("#new-table-li",$pageHome);
				$.mobile.silentScroll(newTableLi.offset().top);
				last_li.addClass("animated flipInX");
				last_li.removeClass("hidden");
				function removeAnimation() {
					// Removes animation class so not triggered again
					last_li.removeClass("animated flipInX");	
				}
				setTimeout(removeAnimation,2000);
			}
		});
}

function reloadTableList() {
		$("#listContainer",$pageHome).empty();
		viewTableList();
}

$(document).ready(function() {
	retrieveTableColors();
	retrieveTableList();
	viewTableList();	
	responsiveFrontpage();
	$($pageHome).on( "pagebeforeshow", function( event ) {
	// Sikrer, at der ikke er tilfælde hvor gameIsActive = true udenfor spil
		if(gameIsActive) {
			resetGame();
		}
		if (!tableDeleted) {
			// Reload table list to update highscore/played times and new tables
			reloadTableList();
		} else {
			tableDeleted = false;
		}
	});
	$("#delete-table",$deleteDialog).on("tap", function() {
		deleteTable(deleteID);
	});
	$(".cancel-delete-table",$deleteDialog).on("tap", function() {
		$deleteDialog.dialog("close");
	});
});


/* Delete table dialog */




/* *************************************************** */
/* ***************** MAKE TABLE ********************** */
/* *************************************************** */
var $makeDialog = $("#make-dialog");
var $selectColor = $("#select-color",$makeDialog);
var $makeForm = $("#make-form",$pageMake);
var makeDialogClosed = false;
// RANGESLIDER
var makeColor;
var complementaryAmount;

function setColor(color) {
	makeColor = color;
	addTableColor($makeForm,makeColor);
	var handle = $(".noUi-handle",$makeForm);
	$(handle).addClass("background");
	addTableColor(handle,makeColor);
	addTableColor($("#select-color-button, #save",$makeDialog),makeColor);
}

function showMakeDialog() {
	$selectColor.empty();
	$(tableColors).each(function(index,color) {
		var option = document.createElement("option");
		option.setAttribute("value",index);
		// Capitalize first letter
		var colorText = color.color.charAt(0).toUpperCase() + color.color.slice(1);
		$(option).text(colorText);
		if (index == makeColor) {
			option.setAttribute("selected","selected")
		}
		$selectColor.append(option);
	});
	 $selectColor.selectmenu("refresh", true);
}

var valX = $("#slideX",$makeForm);
var valY = $("#slideY",$makeForm);
var $complementarySwitch = $("#complementary",$makeDialog);
function slide() {
	var x = valX.val();
	var y = valY.val();
	x1 = x[0];
	x2 = x[1];
	y1 = y[0];
	y2 = y[1];
	complementary = $complementarySwitch.val() == '0';
	$tableMake.empty();
	makeTable();
	responsive();
	if(!complementary) {
		complementaryAmount = removeComplementary();
	} else {
		complementaryAmount = 0;	
	}
}

function resetSlider() {
	// Set complementary = true
	$complementarySwitch.val(0);
	// Reset slider values
	$(".sliders").val([1, 9]);
	// Pick & select color
	setColor(pickColor());
	// Update table with new values
	slide();
}

function toggle( value ){
	$(this).toggleClass('on', value === "1");
	slide();      
}

$(function(){
	// Create Rangesliders
	$('.sliders').noUiSlider({
		start: [1,9],
		step: 1,
		format: wNumb({
			decimals: 0
		}),
		connect: true,
		range: {
			'min': 1,
			'max': 20
		}
	});
	// Create Switch
	$($complementarySwitch).noUiSlider({
		start: 0,
		range: {
			'min': [0, 1],
			'max': 1
		},
		format: wNumb({
			decimals: 0
		})
	})
	$('#slideX',$makeForm).Link('lower').to($('#valX1'));
	$('#slideX',$makeForm).Link('upper').to($('#valX2'));
	$('#slideY',$makeForm).Link('lower').to($('#valY1'));
	$('#slideY',$makeForm).Link('upper').to($('#valY2'));
	$($complementarySwitch).Link('lower').to(toggle);
});

$(".sliders").on({
	// Change event: updates only on user input. Prevents calling on reset.
	change: slide
});

$(document).ready(function() {	
	// Select list on change
	/* PAGEmake*/
	$($pageMake).on( "pagebeforeshow", function( event ) {
		if (makeDialogClosed) {
			makeDialogClosed = false;
			return;
		}
		resetSlider();
	});
	// On submit new table
	$("#saveNewTable").click(function( event ) { 
	  if (complementaryAmount == 0) {
		  // To avoid duplicated, set dup=true, if none;
		  complementary = true;
	  }
	  var id = "table" + [x1,x2,y1,y2,complementary].join("-");
	  if (typeof playedTables[id] != "undefined") {
	  // Check whether table is already made
		  $("#exists-info",$pageMake).text("The " + nameTable(id) + " you've made already exists!");
		  $("#exists-already").popup("open");
		  return;
	  }
	  addTable([x1,x2,y1,y2,complementary],makeColor,true);
	  newItemAdded = true;
	  $("body").pagecontainer("change", $pageHome, {transition: 'slidedown'});
	});  
});

/* *************************************************** */
/* ***************** MAKE DIALOG ********************* */
/* *************************************************** */
$($selectColor).change(function() {
	setColor($(this).val());
});

$($complementarySwitch).change(function() {
	slide();	
});	


$(".close-dialog",$makeDialog).on("tap", function( event ) {
	makeDialogClosed = true;
	$makeDialog.dialog("close");
});

$($makeDialog).on( "pagebeforeshow", function( event ) {
	showMakeDialog();
	setColor(makeColor);
	// Set switch equals current value. Ensures in sync. 
	var setValue = complementary == true ? "true" : "false"
	//$($complementarySwitch).val(setValue).slider('refresh');
});


/* *************************************************** */
/* ***************** Page-stats ********************** */
/* *************************************************** */
var statScore = [];
var statErrors = [];
var statDate=[];
var statContainer = $("#canvascontainer",$pageStats);
var statCanvas;
var statNumber = [];
var ctx;

function chartResponsive() {
	//var marginBottom = $("#stat-footer",$pageStats).actual("height")+6; // Height + 6 px padding
	var marginBottom = 60;
	var width = $(window).width()-10;
	var height = $(window).height()-marginTop-marginBottom-15; // 5px margin top&bottom	
	$(statCanvas).attr("width",width);
	$(statCanvas).attr("height",height);
}

function drawLineChart(color) {
	var rgba = color.replace(')', ', 0.45)').replace('rgb', 'rgba');
	var lineChartData = {
		labels : statNumber,
		datasets : [
			{
				label: "My Second dataset",
				fillColor : color.replace(')', ', 0.2)').replace('rgb', 'rgba'),
				strokeColor : color,
				pointColor : "#ddd",
				scaleGridLineColor : "rgba(0,0,0,.05)",
				tooltipFillColor: "rgba(0,0,0,0.8)",
				tooltipTitleFontColor: "#fff",
				pointStrokeColor : "#1f2739",
				pointHighlightFill : "#fff",
				pointHighlightStroke : "rgba(151,187,205,1)",
				data : statScore
			}
		]
	}
	ctx = document.getElementById("canvas").getContext("2d");
	// Get orginal canvas size before drawing, to fix problem with dubling in size
	ctx.canvas.originalwidth = ctx.canvas.width;
	ctx.canvas.originalheight = ctx.canvas.height;
	ctx.clearRect(0, 0, canvas.width, canvas.height);
	// Set canvas size to original before drawing
	ctx.canvas.width = ctx.canvas.originalwidth;
    ctx.canvas.height = ctx.canvas.originalheight;
	window.myLine = new Chart(ctx).Line(lineChartData, {
		showTooltips: true,
		scaleFontColor: "#ddd",
		scaleLabel : "<%= timeShort(value) %>",
		scaleGridLineColor : "#2C3446",
		tooltipTemplate: "<%if (label){%><%=statDate[index]%>: <%=time(statScore[index])%>, <%=statErrors[index]%> errors<%}%>"
	});
}

function formatDate(date) {
	var time = new Date(date);
	return navigator.globalization.dateToString(
		time,
		function(date) {statDate.push(date.value)},
		function() {return false},
		{formatLength:'short', selector:'date'});
}

//$($pageStats).on( "pagebeforeshow", function( event ) {
function makeChart(id) {
	//var id = "table1-2-1-1-true";
	$(statContainer).empty();
	// Create canvas
	statCanvas = document.createElement("canvas");
	$(statCanvas).attr("id","canvas");
	$(statContainer).append(statCanvas);
	$(statCanvas).parents("*").css("overflow", "visible");
	// Retrieve data from local storage
	var tableData = retrieveTableData(id);
	// Get color of current table in rgb
	var color = $("#"+id,$pageHome).css('backgroundColor');
	$("#stats-title",$pageStats).text(nameTable(id));
	statScore = [];
	statNumber = [];
	statErrors = [];
	statDate=[];
	var time = 0;
	$(tableData).each(function(index, element) {
        statScore.push(element[0]);
		statErrors.push(element[1]);
		formatDate(element[2]);
		statNumber.push(++time);
    });
	chartResponsive();
	drawLineChart(color);
}

/* *************************************************** */
/* ***************** NAVIGATION ********************** */
/* *************************************************** */
function pageBack() {
	var activePage = $.mobile.activePage.attr('id');
	switch(activePage) {
    case 'page-make':
        var transition = 'slideup';
        break;
    case 'page-stats':
        var transition = 'fade';
        break;
    default:
        var transition = 'slide';
	}
	$("body").pagecontainer("change", $pageHome, {
		transition: transition,
		reverse: true
	});
}

$(document).ready(function() {
	document.addEventListener("backbutton", function(e){
		e.preventDefault();
		var activePage = $.mobile.activePage.attr('id');
		if (activePage == "page-home"){
			navigator.app.exitApp();
			return;
    	} else {
   			pageBack();
		}
	}, false);
	$(".page-back").bind('touchstart', function(){
		pageBack();
	});	
});
